using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Threading;

namespace Asst1
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;

		int[,] red;
		int [,] green;
		int[,] blue;

		bool drawingDone = true;

		Point mousePos;

		int[,] gray;

		int[] redAcc, greenAcc, blueAcc, grayAcc;

		int redSelected = -1;
		int greenSelected = -1;
		int blueSelected = -1;

		string title1 = "Assignment 1";
		string title2 = "Assignment 2";

		bool[,] PixelsChecked;

		int threshold = 128;

		int boxWidth = 11;
		private System.Windows.Forms.TabControl tabControl1;
		private System.Windows.Forms.TabPage tabPage1;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.PictureBox pictureBox7;
		private System.Windows.Forms.PictureBox pictureBox4;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.PictureBox pictureBox6;
		private System.Windows.Forms.PictureBox pictureBox3;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.PictureBox pictureBox5;
		private System.Windows.Forms.PictureBox pictureBox2;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Timer timer1;
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.StatusBarPanel statusBarPanel1;
		private System.Windows.Forms.StatusBarPanel statusBarPanel2;
		private System.Windows.Forms.TabPage tabPage2;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Panel panel3;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TrackBar trackBar1;
		private System.Windows.Forms.PictureBox pictureBox8;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.PictureBox pictureBox9;
		private System.Windows.Forms.OpenFileDialog openFileDialog2;

		Image origImage, origImage2;
		private System.Windows.Forms.RadioButton radioButton1;
		private System.Windows.Forms.RadioButton radioButton2;
		private System.Windows.Forms.CheckBox checkBox1;

		public Form1(){

			mousePos = new Point(-1,-1);

			redAcc = new int[256];
			greenAcc = new int[256];
			blueAcc = new int[256];
			
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			this.Layout += new System.Windows.Forms.LayoutEventHandler(this.Form1_Layout);
			tabPage1.Layout += new LayoutEventHandler(this.TabPage1_Layout);

			tabPage2.Layout += new LayoutEventHandler(tabPage2_Layout);

			tabPage2.VisibleChanged += new EventHandler(tabPage2_VisibleChanged);
			tabPage1.VisibleChanged += new EventHandler(tabPage1_VisibleChanged);

			pictureBox1.MouseMove += new MouseEventHandler(pictureBox1_MouseMove);
			pictureBox1.MouseDown += new MouseEventHandler(pictureBox1_MouseDown);
			pictureBox1.MouseLeave +=new EventHandler(pictureBox1_MouseLeave);

			pictureBox2.MouseMove += new MouseEventHandler(pictureBox2_MouseMove);
			pictureBox2.MouseLeave += new EventHandler(pictureBox2_MouseLeave);

			pictureBox3.MouseMove += new MouseEventHandler(pictureBox3_MouseMove);
			pictureBox3.MouseLeave += new EventHandler(pictureBox3_MouseLeave);

			pictureBox4.MouseMove += new MouseEventHandler(pictureBox4_MouseMove);
			pictureBox4.MouseLeave += new EventHandler(pictureBox4_MouseLeave);

			pictureBox1.Paint += new PaintEventHandler(pictureBox1_Paint);

			//pictureBox9.Paint += new PaintEventHandler(pictureBox9_Paint);

			pictureBox2.Paint += new PaintEventHandler(pictureBox2_Paint);
			pictureBox3.Paint += new PaintEventHandler(pictureBox3_Paint);
			pictureBox4.Paint += new PaintEventHandler(pictureBox4_Paint);

			pictureBox5.Paint += new PaintEventHandler(pictureBox5_Paint);
			pictureBox6.Paint += new PaintEventHandler(pictureBox5_Paint);
			pictureBox7.Paint += new PaintEventHandler(pictureBox5_Paint);

			pictureBox8.Paint += new PaintEventHandler(pictureBox8_Paint);

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.tabControl1 = new System.Windows.Forms.TabControl();
			this.tabPage1 = new System.Windows.Forms.TabPage();
			this.panel1 = new System.Windows.Forms.Panel();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.pictureBox6 = new System.Windows.Forms.PictureBox();
			this.pictureBox3 = new System.Windows.Forms.PictureBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.pictureBox5 = new System.Windows.Forms.PictureBox();
			this.pictureBox2 = new System.Windows.Forms.PictureBox();
			this.button1 = new System.Windows.Forms.Button();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.pictureBox7 = new System.Windows.Forms.PictureBox();
			this.pictureBox4 = new System.Windows.Forms.PictureBox();
			this.tabPage2 = new System.Windows.Forms.TabPage();
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			this.panel3 = new System.Windows.Forms.Panel();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.trackBar1 = new System.Windows.Forms.TrackBar();
			this.pictureBox8 = new System.Windows.Forms.PictureBox();
			this.panel2 = new System.Windows.Forms.Panel();
			this.pictureBox9 = new System.Windows.Forms.PictureBox();
			this.button3 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.timer1 = new System.Windows.Forms.Timer(this.components);
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.statusBarPanel1 = new System.Windows.Forms.StatusBarPanel();
			this.statusBarPanel2 = new System.Windows.Forms.StatusBarPanel();
			this.openFileDialog2 = new System.Windows.Forms.OpenFileDialog();
			this.radioButton1 = new System.Windows.Forms.RadioButton();
			this.radioButton2 = new System.Windows.Forms.RadioButton();
			this.tabControl1.SuspendLayout();
			this.tabPage1.SuspendLayout();
			this.panel1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox1.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.tabPage2.SuspendLayout();
			this.panel3.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.trackBar1)).BeginInit();
			this.panel2.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel2)).BeginInit();
			this.SuspendLayout();
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.Add(this.tabPage1);
			this.tabControl1.Controls.Add(this.tabPage2);
			this.tabControl1.ItemSize = new System.Drawing.Size(128, 18);
			this.tabControl1.Location = new System.Drawing.Point(0, 0);
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.Size = new System.Drawing.Size(848, 757);
			this.tabControl1.SizeMode = System.Windows.Forms.TabSizeMode.Fixed;
			this.tabControl1.TabIndex = 0;
			// 
			// tabPage1
			// 
			this.tabPage1.Controls.Add(this.panel1);
			this.tabPage1.Controls.Add(this.groupBox2);
			this.tabPage1.Controls.Add(this.groupBox1);
			this.tabPage1.Controls.Add(this.button1);
			this.tabPage1.Controls.Add(this.groupBox3);
			this.tabPage1.Location = new System.Drawing.Point(4, 22);
			this.tabPage1.Name = "tabPage1";
			this.tabPage1.Size = new System.Drawing.Size(840, 731);
			this.tabPage1.TabIndex = 0;
			this.tabPage1.Text = "Ex 1.2";
			// 
			// panel1
			// 
			this.panel1.AutoScroll = true;
			this.panel1.BackColor = System.Drawing.SystemColors.AppWorkspace;
			this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panel1.Controls.Add(this.pictureBox1);
			this.panel1.Location = new System.Drawing.Point(8, 40);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(832, 448);
			this.panel1.TabIndex = 7;
			// 
			// pictureBox1
			// 
			this.pictureBox1.BackColor = System.Drawing.SystemColors.AppWorkspace;
			this.pictureBox1.Location = new System.Drawing.Point(8, 8);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(24, 16);
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.pictureBox6);
			this.groupBox2.Controls.Add(this.pictureBox3);
			this.groupBox2.Location = new System.Drawing.Point(288, 498);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(272, 200);
			this.groupBox2.TabIndex = 9;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Green Histogram";
			// 
			// pictureBox6
			// 
			this.pictureBox6.Location = new System.Drawing.Point(8, 186);
			this.pictureBox6.Name = "pictureBox6";
			this.pictureBox6.Size = new System.Drawing.Size(256, 8);
			this.pictureBox6.TabIndex = 2;
			this.pictureBox6.TabStop = false;
			// 
			// pictureBox3
			// 
			this.pictureBox3.BackColor = System.Drawing.Color.White;
			this.pictureBox3.Location = new System.Drawing.Point(8, 16);
			this.pictureBox3.Name = "pictureBox3";
			this.pictureBox3.Size = new System.Drawing.Size(256, 168);
			this.pictureBox3.TabIndex = 0;
			this.pictureBox3.TabStop = false;
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.pictureBox5);
			this.groupBox1.Controls.Add(this.pictureBox2);
			this.groupBox1.Location = new System.Drawing.Point(8, 498);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(272, 200);
			this.groupBox1.TabIndex = 8;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Red Histogram";
			// 
			// pictureBox5
			// 
			this.pictureBox5.Location = new System.Drawing.Point(8, 186);
			this.pictureBox5.Name = "pictureBox5";
			this.pictureBox5.Size = new System.Drawing.Size(256, 8);
			this.pictureBox5.TabIndex = 1;
			this.pictureBox5.TabStop = false;
			// 
			// pictureBox2
			// 
			this.pictureBox2.BackColor = System.Drawing.Color.White;
			this.pictureBox2.Location = new System.Drawing.Point(8, 16);
			this.pictureBox2.Name = "pictureBox2";
			this.pictureBox2.Size = new System.Drawing.Size(256, 168);
			this.pictureBox2.TabIndex = 0;
			this.pictureBox2.TabStop = false;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(8, 8);
			this.button1.Name = "button1";
			this.button1.TabIndex = 6;
			this.button1.Text = "Open";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.Add(this.pictureBox7);
			this.groupBox3.Controls.Add(this.pictureBox4);
			this.groupBox3.Location = new System.Drawing.Point(568, 498);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(272, 200);
			this.groupBox3.TabIndex = 10;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "Blue Histogram";
			// 
			// pictureBox7
			// 
			this.pictureBox7.Location = new System.Drawing.Point(8, 186);
			this.pictureBox7.Name = "pictureBox7";
			this.pictureBox7.Size = new System.Drawing.Size(256, 8);
			this.pictureBox7.TabIndex = 2;
			this.pictureBox7.TabStop = false;
			// 
			// pictureBox4
			// 
			this.pictureBox4.BackColor = System.Drawing.Color.White;
			this.pictureBox4.Location = new System.Drawing.Point(8, 16);
			this.pictureBox4.Name = "pictureBox4";
			this.pictureBox4.Size = new System.Drawing.Size(256, 168);
			this.pictureBox4.TabIndex = 0;
			this.pictureBox4.TabStop = false;
			// 
			// tabPage2
			// 
			this.tabPage2.Controls.Add(this.radioButton2);
			this.tabPage2.Controls.Add(this.radioButton1);
			this.tabPage2.Controls.Add(this.checkBox1);
			this.tabPage2.Controls.Add(this.panel3);
			this.tabPage2.Controls.Add(this.panel2);
			this.tabPage2.Controls.Add(this.button3);
			this.tabPage2.Controls.Add(this.button2);
			this.tabPage2.Location = new System.Drawing.Point(4, 22);
			this.tabPage2.Name = "tabPage2";
			this.tabPage2.Size = new System.Drawing.Size(840, 731);
			this.tabPage2.TabIndex = 1;
			this.tabPage2.Text = "Ex 2.2";
			// 
			// checkBox1
			// 
			this.checkBox1.Checked = true;
			this.checkBox1.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBox1.Location = new System.Drawing.Point(184, 8);
			this.checkBox1.Name = "checkBox1";
			this.checkBox1.Size = new System.Drawing.Size(80, 24);
			this.checkBox1.TabIndex = 4;
			this.checkBox1.Text = "Colourize";
			// 
			// panel3
			// 
			this.panel3.Controls.Add(this.label2);
			this.panel3.Controls.Add(this.label1);
			this.panel3.Controls.Add(this.trackBar1);
			this.panel3.Controls.Add(this.pictureBox8);
			this.panel3.Location = new System.Drawing.Point(232, 360);
			this.panel3.Name = "panel3";
			this.panel3.Size = new System.Drawing.Size(368, 160);
			this.panel3.TabIndex = 3;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 120);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(56, 23);
			this.label2.TabIndex = 9;
			this.label2.Text = "Threshold";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(336, 120);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(24, 23);
			this.label1.TabIndex = 8;
			this.label1.Text = "128";
			// 
			// trackBar1
			// 
			this.trackBar1.LargeChange = 16;
			this.trackBar1.Location = new System.Drawing.Point(64, 112);
			this.trackBar1.Maximum = 255;
			this.trackBar1.Name = "trackBar1";
			this.trackBar1.Size = new System.Drawing.Size(272, 42);
			this.trackBar1.TabIndex = 7;
			this.trackBar1.TickFrequency = 16;
			this.trackBar1.TickStyle = System.Windows.Forms.TickStyle.TopLeft;
			this.trackBar1.Value = 128;
			this.trackBar1.Scroll += new System.EventHandler(this.trackBar1_Scroll);
			// 
			// pictureBox8
			// 
			this.pictureBox8.BackColor = System.Drawing.Color.White;
			this.pictureBox8.Location = new System.Drawing.Point(72, 8);
			this.pictureBox8.Name = "pictureBox8";
			this.pictureBox8.Size = new System.Drawing.Size(256, 100);
			this.pictureBox8.TabIndex = 6;
			this.pictureBox8.TabStop = false;
			// 
			// panel2
			// 
			this.panel2.AutoScroll = true;
			this.panel2.BackColor = System.Drawing.SystemColors.AppWorkspace;
			this.panel2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panel2.Controls.Add(this.pictureBox9);
			this.panel2.Location = new System.Drawing.Point(8, 40);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(776, 312);
			this.panel2.TabIndex = 2;
			// 
			// pictureBox9
			// 
			this.pictureBox9.Location = new System.Drawing.Point(8, 8);
			this.pictureBox9.Name = "pictureBox9";
			this.pictureBox9.Size = new System.Drawing.Size(136, 96);
			this.pictureBox9.TabIndex = 0;
			this.pictureBox9.TabStop = false;
			// 
			// button3
			// 
			this.button3.Enabled = false;
			this.button3.Location = new System.Drawing.Point(96, 8);
			this.button3.Name = "button3";
			this.button3.TabIndex = 1;
			this.button3.Text = "Threshold";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(8, 8);
			this.button2.Name = "button2";
			this.button2.TabIndex = 0;
			this.button2.Text = "Open";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// timer1
			// 
			this.timer1.Enabled = true;
			this.timer1.Interval = 1000;
			this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 551);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																						  this.statusBarPanel1,
																						  this.statusBarPanel2});
			this.statusBar1.ShowPanels = true;
			this.statusBar1.Size = new System.Drawing.Size(848, 22);
			this.statusBar1.TabIndex = 12;
			// 
			// statusBarPanel1
			// 
			this.statusBarPanel1.Width = 300;
			// 
			// statusBarPanel2
			// 
			this.statusBarPanel2.Width = 2000;
			// 
			// radioButton1
			// 
			this.radioButton1.Checked = true;
			this.radioButton1.Location = new System.Drawing.Point(272, 0);
			this.radioButton1.Name = "radioButton1";
			this.radioButton1.TabIndex = 5;
			this.radioButton1.TabStop = true;
			this.radioButton1.Text = "White is Object";
			// 
			// radioButton2
			// 
			this.radioButton2.Location = new System.Drawing.Point(272, 16);
			this.radioButton2.Name = "radioButton2";
			this.radioButton2.TabIndex = 6;
			this.radioButton2.Text = "Black is Object";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(848, 573);
			this.Controls.Add(this.statusBar1);
			this.Controls.Add(this.tabControl1);
			this.Name = "Form1";
			this.Text = "Assignment 1";
			this.tabControl1.ResumeLayout(false);
			this.tabPage1.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			this.tabPage2.ResumeLayout(false);
			this.panel3.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.trackBar1)).EndInit();
			this.panel2.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel2)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		

		private void button1_Click(object sender, System.EventArgs e){
			openFileDialog1.AddExtension = true;
			openFileDialog1.Filter = "Bitmap Files|*.bmp|TIFF Files|*.tif|JPEG Files|*.jpg";
			
			openFileDialog1.CheckFileExists = true;
			DialogResult dr = openFileDialog1.ShowDialog(this);


			if(!(dr == DialogResult.OK || dr == DialogResult.Yes))
				return;
			Bitmap b = new Bitmap(Image.FromFile(openFileDialog1.FileName));

			

			//FileInfo f = new FileInfo(openFileDialog1.FileName);
			
			this.Text = title1 = "Assignment 1 - "+new FileInfo(openFileDialog1.FileName).Name;
			
			

			origImage = b;

			pictureBox1.Image = (Image)b.Clone();
			pictureBox1.Width = b.Width;
			pictureBox1.Height = b.Height;
			pictureBox1.Invalidate();


			ExtractPixels(b);

			DoHistogram();
			//DoGreenHistogram();
			//DoBlueHistogram();


			pictureBox2.Invalidate();
			pictureBox3.Invalidate();
			pictureBox4.Invalidate();
		
		}


		private void Form1_Layout(object sender, LayoutEventArgs e) {
			tabControl1.Width = this.Width-8;
			tabControl1.Height = this.Height - 50;
		}

		private void TabPage1_Layout(object sender, LayoutEventArgs e) {
			panel1.Width = tabPage1.Width-(2*panel1.Location.X+6);

			panel1.Height = tabPage1.Height-(panel1.Location.Y+210);

			groupBox1.Location = new System.Drawing.Point(groupBox1.Location.X, tabPage1.Height-207);
			groupBox2.Location = new System.Drawing.Point(groupBox2.Location.X, tabPage1.Height-207);
			groupBox3.Location = new System.Drawing.Point(groupBox3.Location.X, tabPage1.Height-207);
		}

		private void ExtractPixels(Bitmap b){
			red = new int[b.Width,b.Height];
			green = new int[b.Width,b.Height];
			blue = new int[b.Width,b.Height];
			
			for(int x=0; x < b.Width; x++){
				for(int y=0; y < b.Height; y++){
					try{
						Color c = b.GetPixel(x,y);
						red[x,y] = (int)c.R;
						green[x,y] = (int)c.G;
						blue[x,y] = (int)c.B;
					}
					catch(Exception){
						MessageBox.Show(""+x+", "+y);
					}
				}
			}
		}

		private void ExtractGrayPixels(Bitmap b){
			gray = new int[b.Width,b.Height];
			
			for(int x=0; x < b.Width; x++){
				for(int y=0; y < b.Height; y++){
					try{
						Color c = b.GetPixel(x,y);
						gray[x,y] = (int)(c.GetBrightness()*255);
					}
					catch(Exception){
						MessageBox.Show(""+x+", "+y);
					}
				}
			}
		}


		private void DoGrayHistogram(){
			grayAcc = new int[256];

			for(int x=0; x < pictureBox9.Image.Width; x++){
				for(int y=0; y <  pictureBox9.Image.Height; y++){
					grayAcc[gray[x,y]]++;
				}
			}
		}

		private double ComputeMean(Bitmap i, int X, int Y, int w){
			double sum = 0;
			int count = 0;
			
			for(int x = Math.Max(X-w/2,0); x <= Math.Min(X+w/2,i.Width-1); x++){			
				for(int y = Math.Max(Y-w/2,0); y <= Math.Min(Y+w/2,i.Height-1); y++){
					sum += i.GetPixel(x,y).GetBrightness()*255;
					count++;
				}
			}

			return sum/count;
		}

		private double ComputeVariance(Bitmap i, int X, int Y, int w){
			double mean = ComputeMean(i, X, Y, w);

			double sum = 0;
			int count = -1;

			for(int x = Math.Max(X-w/2,0); x <= Math.Min(X+w/2,i.Width-1); x++){			
				for(int y = Math.Max(Y-w/2,0); y <= Math.Min(Y+w/2,i.Height-1); y++){
					double temp = (i.GetPixel(x,y).GetBrightness()*255 - mean);
					sum += temp*temp;	
					count++;
				}
			}

			return sum/count;


		
		}


		private void DoHistogram(){
			redAcc = new int[256];
			greenAcc = new int[256];
			blueAcc = new int[256];

			for(int x=0; x < pictureBox1.Image.Width; x++){
				for(int y=0; y <  pictureBox1.Image.Height; y++){
					redAcc[red[x,y]]++;
					greenAcc[green[x,y]]++;
					blueAcc[blue[x,y]]++;
				}
			}
		}

		/*private void DoGreenHistogram(){
			greenAcc = new int[256];

			for(int x=0; x <  pictureBox1.Image.Width; x++){
				for(int y=0; y <  pictureBox1.Image.Height; y++){
					
				}
			}
		}
		

		private void DoBlueHistogram(){
			blueAcc = new int[256];

			for(int x=0; x <  pictureBox1.Image.Width; x++){
				for(int y=0; y <  pictureBox1.Image.Height; y++){
					
				}
			}
		}*/

		private void pictureBox2_Paint(object sender, PaintEventArgs e) {
			if(pictureBox1.Image == null)
				return;

			if(pictureBox2.Image == null){
				pictureBox2.Image = new Bitmap(pictureBox2.Width,pictureBox2.Height);
			}
			Graphics g = Graphics.FromImage(pictureBox2.Image);

			g.FillRectangle(Brushes.White,0,0,pictureBox2.Width,pictureBox2.Height);
		
			int maxAcc = 0;
			for(int i=0; i < 256; i++){
				if(redAcc[i] > maxAcc)maxAcc = redAcc[i];
			}
			if(maxAcc == 0)return;

			//maxAcc = pictureBox2.Width*pictureBox2.Height;

			double divFactor = ((double)pictureBox2.Height)/(maxAcc);
			
			int[] redAcc2 = new int[256];
			for(int i=0; i < 256; i++){
				Pen p;
				if(i == redSelected)
					p = new Pen(Brushes.Red);
				else p = new Pen(Brushes.Black);
				redAcc2[i] = (int)(redAcc[i]*divFactor);
				if(i < 255)
					g.DrawLine(p,(int)i,(int)(pictureBox2.Height),(int)i,(int)(pictureBox2.Height - redAcc2[i]));
				else g.DrawLine(p,(int)i,(int)(pictureBox2.Height),(int)i,(int)(pictureBox2.Height - redAcc2[i]));
			}

		}


		private void pictureBox3_Paint(object sender, PaintEventArgs e) {
			if(pictureBox1.Image == null)
				return;

			if(pictureBox3.Image == null){
				pictureBox3.Image = new Bitmap(pictureBox3.Width,pictureBox3.Height);
			}
			Graphics g = Graphics.FromImage(pictureBox3.Image);

			g.FillRectangle(Brushes.White,0,0,pictureBox3.Width,pictureBox3.Height);
		
			int maxAcc = 0;
			for(int i=0; i < 256; i++){
				if(greenAcc[i] > maxAcc)maxAcc = greenAcc[i];
			}
			if(maxAcc == 0)return;

			//maxAcc = pictureBox3.Width*pictureBox3.Height;

			double divFactor = ((double)pictureBox3.Height)/(maxAcc);

			int[] greenAcc2 = new int[256];
			for(int i=0; i < 256; i++){
				Pen p;
				if(i == greenSelected)
					p = new Pen(Brushes.Red);
				else p = new Pen(Brushes.Black);
				greenAcc2[i] = (int)(greenAcc[i]*divFactor);
				if(i < 255)
					g.DrawLine(p,(int)i+1,(int)(pictureBox2.Height),(int)i+1,(int)(pictureBox2.Height - greenAcc2[i]));
				else g.DrawLine(p,(int)i,(int)(pictureBox2.Height),(int)i,(int)(pictureBox2.Height - greenAcc2[i]));
			}

		}


		private void pictureBox4_Paint(object sender, PaintEventArgs e) {
			if(pictureBox1.Image == null)
				return;

			if(pictureBox4.Image == null){
				pictureBox4.Image = new Bitmap(pictureBox4.Width,pictureBox4.Height);
			}
			Graphics g = Graphics.FromImage(pictureBox4.Image);

			g.FillRectangle(Brushes.White,0,0,pictureBox4.Width,pictureBox4.Height);
		
			int maxAcc = 0;
			for(int i=0; i < 256; i++){
				if(blueAcc[i] > maxAcc)maxAcc = blueAcc[i];
			}
			if(maxAcc == 0)return;

			//maxAcc = pictureBox4.Width*pictureBox4.Height;

			double divFactor = ((double)pictureBox4.Height)/(maxAcc);

			int[] blueAcc2 = new int[256];
			for(int i=0; i < 256; i++){
				Pen p;
				if(i == blueSelected)
					p = new Pen(Brushes.Red);
				else p = new Pen(Brushes.Black);
				blueAcc2[i] = (int)(blueAcc[i]*divFactor);
				if(i < 255)
					g.DrawLine(p,(int)i+1,(int)(pictureBox2.Height),(int)i+1,(int)(pictureBox2.Height - blueAcc2[i]));
				else g.DrawLine(p,(int)i,(int)(pictureBox2.Height),(int)i,(int)(pictureBox2.Height - blueAcc2[i]));
			}

		}

		private void timer1_Tick(object sender, System.EventArgs e) {
			pictureBox2.Invalidate();
			pictureBox3.Invalidate();
			pictureBox4.Invalidate();
			pictureBox8.Invalidate();
		}

		private void pictureBox5_Paint(object sender, PaintEventArgs e) {
			Graphics g = e.Graphics;
			Color bas;

			if(sender == pictureBox5)
				bas = Color.Red;
			else if(sender == pictureBox6)
				bas = Color.Green;
			else if(sender == pictureBox7)
				bas = Color.Blue;
			else bas = Color.White;

			g.FillRectangle(new LinearGradientBrush(new Rectangle(0,0,pictureBox5.Width,pictureBox5.Height),Color.Black,bas,0.0f,false),0,0,pictureBox5.Width,pictureBox5.Height);
		}

		
		private void pictureBox9_Paint(object sender, PaintEventArgs e) {
			Image i = pictureBox9.Image;
			if(i == null)
				return;

			e.Graphics.DrawImageUnscaled(i,0,0,0,0);
		}
		
		private void pictureBox1_Paint(object sender, PaintEventArgs e) {
			if(origImage == null)
				return;

			if((Object)mousePos == null || mousePos.X < 0 ||  mousePos.Y < 0){
				Graphics h = e.Graphics;
				h.DrawImage(origImage, new PointF(0.0f,0.0f));
				return;
			}



			//Image i = (Image)origImage.Clone();
			Bitmap b  = new Bitmap(origImage);
			Graphics g = Graphics.FromImage(b);
		

			Color c = b.GetPixel(mousePos.X,mousePos.Y);

			Brush br;

			int bri = (int)(c.GetBrightness()*255);
			if(bri < 156 && bri > 100)
				br = Brushes.Black;
			else br = new SolidBrush(Color.FromArgb(255-c.R,255-c.G,255-c.B));

			g.SmoothingMode = SmoothingMode.HighSpeed;
			g.TextRenderingHint = System.Drawing.Text.TextRenderingHint.SingleBitPerPixelGridFit;
		
			g.DrawRectangle(new Pen(br,1.0f),mousePos.X-boxWidth/2-1,mousePos.Y-boxWidth/2-1,boxWidth+1,boxWidth+1);			
		
			g.DrawString("("+mousePos.X+", "+mousePos.Y+") "+c.R+","+c.G+","+c.B,new Font("arial",8.0f),br,new RectangleF(new PointF((float)mousePos.X-boxWidth/2,(float)(mousePos.Y-boxWidth/2-17)),new SizeF(150.0f,16.0f)));

			g.DrawString("I = "+(int)(c.GetBrightness()*255)+" M = "+(int)ComputeMean(b,mousePos.X,mousePos.Y,boxWidth) + " V = "+(int)ComputeVariance(b,mousePos.X,mousePos.Y,boxWidth),new Font("arial",8.0f), br,new RectangleF(new PointF((float)mousePos.X-boxWidth/2+15,(float)(mousePos.Y+boxWidth/2+1)),new SizeF(150.0f,16.0f)));

			b.SetPixel(mousePos.X,mousePos.Y,Color.FromArgb(255-c.R,255-c.G,255-c.B));
		
			//pictureBox1.Image = b;
			e.Graphics.DrawImage(b, new PointF(0.0f,0.0f));
		}
		
		private void pictureBox1_MouseMove(object sender, MouseEventArgs e) {
			mousePos = new Point(e.X,e.Y);
			pictureBox1.Invalidate();

			statusBarPanel1.Text = "("+e.X+", "+e.Y+")";

		}

		private void pictureBox1_MouseLeave(object sender, EventArgs e) {
			//MessageBox.Show("Left!");
			mousePos = new Point(-1,-1);
			pictureBox1.Invalidate();
		}

		private void pictureBox1_MouseDown(object sender, MouseEventArgs e) {
			if(origImage == null)
				return;

			Bitmap i = new Bitmap((Image)origImage.Clone());

			for(int x = Math.Max(e.X-boxWidth/2,0); x <= Math.Min(e.X+boxWidth/2,i.Width-1); x++){
			
				for(int y = Math.Max(e.Y-boxWidth/2,0); y <= Math.Min(e.Y+boxWidth/2,i.Height-1); y++){
					Color c = i.GetPixel(x,y);
					i.SetPixel(x,y,Color.FromArgb(255-c.R,255-c.G,255-c.B));
				}
			
			}

			

			origImage = i;

			pictureBox1.Image = (Image)i.Clone();

			ExtractPixels(i);
			DoHistogram();
		}

		private void pictureBox2_MouseMove(object sender, MouseEventArgs e) {
			statusBarPanel1.Text = "Gray Level: "+e.X+"    Frequency: "+redAcc[e.X];
			redSelected = e.X;
			pictureBox2.Invalidate();
		}

		private void pictureBox2_MouseLeave(object sender, EventArgs e) {
			redSelected = -1;
			statusBarPanel1.Text = "";
			pictureBox2.Invalidate();
		}

		private void pictureBox3_MouseMove(object sender, MouseEventArgs e) {
			statusBarPanel1.Text = "Gray Level: "+e.X+"    Frequency: "+greenAcc[e.X];
			greenSelected = e.X;
			pictureBox3.Invalidate();
		}

		private void pictureBox3_MouseLeave(object sender, EventArgs e) {
			greenSelected = -1;
			statusBarPanel1.Text = "";
			pictureBox3.Invalidate();
		}

		private void pictureBox4_MouseMove(object sender, MouseEventArgs e) {
			statusBarPanel1.Text = "Gray Level: "+e.X+"    Frequency: "+blueAcc[e.X];
			blueSelected = e.X;
			pictureBox4.Invalidate();
		}

		private void pictureBox4_MouseLeave(object sender, EventArgs e) {
			blueSelected = -1;
			statusBarPanel1.Text = "";
			pictureBox4.Invalidate();
		}

		private void trackBar1_Scroll(object sender, System.EventArgs e) {
			threshold = trackBar1.Value;
			label1.Text = ""+trackBar1.Value;
			pictureBox8.Invalidate();

			Bitmap b = new Bitmap((Image)origImage2.Clone());
			DoThreshold(b,threshold);

			pictureBox9.Image = b;
			//pictureBox9.Invalidate();
		}

		private void tabPage2_Layout(object sender, LayoutEventArgs e) {
			panel3.Location = new Point((tabPage2.Width-panel3.Width)/2,tabPage2.Height-160);
			panel2.Height = tabPage2.Height-200-panel2.Location.X;
			panel2.Width = tabPage2.Width-15;
		}

		private void pictureBox8_Paint(object sender, PaintEventArgs e) {
			if(pictureBox9.Image == null)
				return;

			if(pictureBox8.Image == null){
				pictureBox8.Image = new Bitmap(pictureBox8.Width,pictureBox8.Height);
			}
			Graphics g = Graphics.FromImage(pictureBox8.Image);

			g.FillRectangle(Brushes.White,0,0,pictureBox8.Width,pictureBox8.Height);
		
			int maxAcc = 0;
			for(int i=0; i < 256; i++){
				if(grayAcc[i] > maxAcc)maxAcc = grayAcc[i];
			}
			if(maxAcc == 0)return;

			//maxAcc = pictureBox4.Width*pictureBox4.Height;

			double divFactor = ((double)pictureBox8.Height)/(maxAcc);

			int[] grayAcc2 = new int[256];
			for(int i=0; i < 256; i++){
				Pen p;
				if(i == threshold)
					p = new Pen(Brushes.Red);
				else p = new Pen(Brushes.Black);
				grayAcc2[i] = (int)(grayAcc[i]*divFactor);
				if(i < 255)
					g.DrawLine(p,(int)i+1,(int)(pictureBox8.Height),(int)i+1,(int)(pictureBox8.Height - grayAcc2[i]));
				else g.DrawLine(p,(int)i,(int)(pictureBox8.Height),(int)i,(int)(pictureBox8.Height - grayAcc2[i]));
			}
		}

		private void button2_Click(object sender, System.EventArgs e) {
			openFileDialog1.AddExtension = true;
			openFileDialog1.Filter = "Bitmap Files|*.bmp|TIFF Files|*.tif|JPEG Files|*.jpg";
			DialogResult dr = openFileDialog1.ShowDialog(this);
			openFileDialog1.CheckFileExists = true;

			if(!(dr == DialogResult.OK || dr == DialogResult.Yes))
				return;

			button3.Enabled = true;

			Bitmap b = new Bitmap(Image.FromFile(openFileDialog1.FileName));
			toGrayscale(b);

			//FileInfo f = new FileInfo(openFileDialog1.FileName);
			
			this.Text = title2 = "Assignment 2 - "+new FileInfo(openFileDialog1.FileName).Name;
			
			
			origImage2 = b;

			pictureBox9.Image = (Image)b.Clone();
			pictureBox9.Width = b.Width;
			pictureBox9.Height = b.Height;
			pictureBox9.Invalidate();


			ExtractGrayPixels(b);

			DoGrayHistogram();
			//DoGreenHistogram();
			//DoBlueHistogram();


			pictureBox2.Invalidate();
			pictureBox3.Invalidate();
			pictureBox4.Invalidate();
		}


		private void toGrayscale(Bitmap b){
			BitmapData bmData = b.LockBits(new Rectangle(0, 0, b.Width, b.Height), ImageLockMode.ReadWrite, PixelFormat.Format24bppRgb);

			int stride = bmData.Stride;
			System.IntPtr Scan0 = bmData.Scan0;

			unsafe {
				byte * p = (byte *)(void *)Scan0;

				int nOffset = stride - b.Width*3;
				int nWidth = b.Width * 3;

				byte[,] pixels = new byte[b.Width,b.Height];
				byte[,] origPixels = new byte[b.Width,b.Height];

				
				// convert the image data to grayscale
				for(int i=0; i < b.Height; i++){
					for(int j=0; j < b.Width; j++){
						int sum = 0;
						for(int k=0; k < 3; k++){
							sum += p[0];
							++p;
						}
						sum /= 3;
						p -= 3;
						for(int k=0; k < 3; k++){
							p[0] = (byte)sum;
							++p;
						}

					}
					p += nOffset;
				}
			}
			b.UnlockBits(bmData);

		}

		private void DoThreshold(Bitmap b, int thr){
			BitmapData bmData = b.LockBits(new Rectangle(0, 0, b.Width, b.Height), ImageLockMode.ReadWrite, PixelFormat.Format24bppRgb);

			int stride = bmData.Stride;
			System.IntPtr Scan0 = bmData.Scan0;

			unsafe {
				byte * p = (byte *)(void *)Scan0;

				int nOffset = stride - b.Width*3;
				int nWidth = b.Width * 3;

				byte[,] pixels = new byte[b.Width,b.Height];
				byte[,] origPixels = new byte[b.Width,b.Height];

				
				// convert the image data to grayscale, and put it into a byte array 
				for(int i=0; i < b.Height; i++){
					for(int j=0; j < b.Width; j++){
						int sum = 0;
						for(int k=0; k < 3; k++){
							sum += p[0];
							++p;
						}
						sum /= 3;
						p -= 3;
						byte pix = 255;
						if (sum <= thr) pix = 0;
						for(int k=0; k < 3; k++){
							p[0] = pix;
							++p;
						}
					}
					p += nOffset;
				}
			}

			b.UnlockBits(bmData);
		}

		private void button3_Click(object sender, System.EventArgs e) {
			Bitmap b = new Bitmap((Image)origImage2.Clone());
			DoThreshold(b,threshold);
			
			if(checkBox1.Checked){
				Random r = new Random();
				PixelsChecked = new bool[b.Width,b.Height];
				int regionCount = 0;
				for(int i=0; i < b.Width; i++){
					for(int j=0; j < b.Height; j++){
						if(!PixelsChecked[i,j]){
							Color c = Color.FromArgb(r.Next(255),r.Next(255),r.Next(255));
							if(radioButton1.Checked && b.GetPixel(i,j).GetBrightness() > 0.5){
								LinearFloodFill4(b, i, j, b.Size, c, b.GetPixel(i,j));
								regionCount++;
							}
							else if(radioButton2.Checked && b.GetPixel(i,j).GetBrightness() < 0.5){
								LinearFloodFill4(b, i, j, b.Size, c, b.GetPixel(i,j));
								regionCount++;
							}
							
								//else LinearFloodFill8(b, i, j, b.Size, c, b.GetPixel(i,j));
							}
					}
				}
				pictureBox9.Image = b;
				MessageBox.Show(regionCount+" regions detected.");
			}
			else{
				pictureBox9.Image = b;
			}


			
			

		}










		public void LinearFloodFill4(Bitmap data, int x, int y, Size bmpsize, Color col, Color origCol){			
			
			// LEFT PROPAGATION----------------------------------------------------------------------------
			int LFillLoc=x;
			while(true){			
				data.SetPixel(LFillLoc,y,col);
				PixelsChecked[LFillLoc,y]=true;
				LFillLoc--;
				if(LFillLoc<=0 || !data.GetPixel(LFillLoc,y).Equals(origCol) ||  (PixelsChecked[LFillLoc,y]))
					break;
				
			}
			LFillLoc++;
			// --------------------------------------------------------------------------------------------
			

			// RIGHT PROPAGATION---------------------------------------------------------------------------
			int RFillLoc=x;

			while(true) {
				data.SetPixel(RFillLoc,y,col);
				PixelsChecked[RFillLoc,y]=true;
				RFillLoc++;
				if(RFillLoc>=bmpsize.Width || !data.GetPixel(RFillLoc,y).Equals(origCol) ||  (PixelsChecked[RFillLoc,y]))
					break;
				
			}
			RFillLoc--;
			// --------------------------------------------------------------------------------------------
					
			for(int i=LFillLoc;i<=RFillLoc;i++) {

				if(y>0) {
					//UP
					if(data.GetPixel(i,y-1).Equals(origCol) && (!(PixelsChecked[i,y-1])))
						LinearFloodFill4(data, i,y-1,bmpsize,col, origCol);
				}
				
				if(y<(bmpsize.Height-1)) {
					//DOWN
					if(data.GetPixel(i,y+1).Equals(origCol) && (!(PixelsChecked[i,y+1])))
						LinearFloodFill4(data, i,y+1,bmpsize,col, origCol);					
				}
			}
			
		}



		public void LinearFloodFill8(Bitmap data, int x, int y, Size bmpsize, Color col, Color origCol){			
			
			int LFillLoc=x;
			while(true){			
				data.SetPixel(LFillLoc,y,col); 
				PixelsChecked[LFillLoc,y]=true;
				LFillLoc--;
				if(LFillLoc<=0 || !data.GetPixel(LFillLoc,y).Equals(origCol) ||  (PixelsChecked[LFillLoc,y]))
					break;
				
			}
			LFillLoc++;
			
			
			int RFillLoc=x;
			while(true) {	
				data.SetPixel(RFillLoc,y,col);
				PixelsChecked[RFillLoc,y]=true;
				RFillLoc++;
				if(RFillLoc>=bmpsize.Width || !data.GetPixel(RFillLoc,y).Equals(origCol) ||  (PixelsChecked[RFillLoc,y]))
					break;
				
			}
			RFillLoc--;
			
			for(int i=LFillLoc;i<=RFillLoc;i++) {

				if(y>0) {
					//UP
					if(data.GetPixel(i,y-1).Equals(origCol) && (!(PixelsChecked[i,y-1])))
						LinearFloodFill4(data, i,y-1,bmpsize,col, origCol);

					if(x>0 && data.GetPixel(i-1,y-1).Equals(origCol) && (!(PixelsChecked[i-1,y-1])))
						LinearFloodFill4(data, i-1,y-1,bmpsize,col, origCol);

					try{
						if(x < (data.Width-2)){
							if(data.GetPixel(i+1,y-1).Equals(origCol) && (!(PixelsChecked[i+1,y-1])))
								LinearFloodFill4(data, i+1,y-1,bmpsize,col, origCol);
						}
					}
					catch(Exception){
					}
				}
				
				if(y<(bmpsize.Height-1)) {
					//DOWN
					if(data.GetPixel(i,y+1).Equals(origCol) && (!(PixelsChecked[i,y+1])))
						LinearFloodFill4(data, i,y+1,bmpsize,col, origCol);	
				
					if(x>0 && data.GetPixel(i-1,y+1).Equals(origCol) && (!(PixelsChecked[i-1,y+1])))
						LinearFloodFill4(data, i-1,y+1,bmpsize,col, origCol);	

					try{
						if(x < (data.Width-2) && data.GetPixel(i+1,y+1).Equals(origCol) && (!(PixelsChecked[i+1,y+1])))
							LinearFloodFill4(data, i+1,y+1,bmpsize,col, origCol);
					}
					catch(Exception){
					}
				}
			}
			
		}

		private void tabPage2_VisibleChanged(object sender, EventArgs e) {
			if(tabPage2.Visible)
				this.Text = title2;
		}

		private void tabPage1_VisibleChanged(object sender, EventArgs e) {
			if(tabPage1.Visible)
				this.Text = title1;
		}

	}
}
